---
title: Using the Debugger map scopes feature
slug: Tools/Debugger/Using_the_Debugger_map_scopes_feature
---
<p>{{ToolsSidebar}}</p>

<p>This feature is useful when debugging source-mapped code. It enables you to see the variables from the original source. It’s also possible to inspect variables from the generated scopes (e.g., a bundle file with all concatenated module files).</p>

<p>Let's take a look at how this works. If you want to follow along, use <a href="https://firefox-dev.tools/debugger-examples/examples/increment/">this example</a>.</p>

<ol>
 <li>Open the <a href="https://firefox-dev.tools/debugger-examples/examples/increment/">example page</a> and then open the debugger using <strong>Tools &gt; Web Developer &gt; Debugger</strong> (or press <kbd>Ctrl</kbd> + <kbd>I</kbd> and then select the debugger).</li>
 <li>Select the "bundle.js" file in the Sources panel on the left and then set a breakpoint at line 102 in the <code>increment</code> function.</li>
 <li>When you click the <strong>increment</strong> button on the page and hit the breakpoint, an additional section is added to the right-hand panel below the Call stack to display variables mapped from the original scope, like this:<br>
  <br>
  <img alt="" src="https://mdn.mozillademos.org/files/16624/debugger_map_scope.png" style="border: 1px solid black; display: block; height: 380px; margin: 0px auto; width: 934px;"></li>
 <li>As useful as this is, it would be even nicer if you could view the original code (before it was packages into the "bundle.js" file. Right-click on the source code and the context menu now includes an option to <strong>Jump to original location</strong> as shown below.<br>
  <br>
  <img alt="" src="https://mdn.mozillademos.org/files/16625/map_scopes_context_menu.png" style="border: 1px solid black; display: block; height: 383px; margin: 0px auto; width: 1136px;"></li>
 <li>Click  <strong>Jump to original location</strong>.  The debugger opens the file "increment.js" so you can view the original code. Notice that your breakpoint is set here in the original code as it was in the corresponding line in the "bundle.js" file. And, since Map has been checked in the Scopes panel, you also see variable symbols from the original code.<br>
  <br>
  <img alt="" src="https://mdn.mozillademos.org/files/16626/map_scopes_original_code.png" style="border: 1px solid black; display: block; margin: 0 auto;"></li>
</ol>

<p>Using this feature is expensive in terms of resources, but it certainly makes your life easier when you have to debug source code that has been packaged webpack or a similar tool.</p>
